// Country.java

package uk.org.redfelineninja.risk.robot;

/**
 * Extended version of Vector with a convenience accessors.
 */
class CountryVector extends java.util.Vector {
    public final Country countryAt(int index) {
        return (Country) (elementData[index] instanceof Country ? elementData[index] : null);
    } // countryAt( int )

    public final synchronized Country firstCountry() {
        return (Country) (elementData[0] instanceof Country ? elementData[0] : null);
    } // firstCountry()

    public final synchronized Country lastCountry() {
        return (Country) (elementData[elementCount - 1] instanceof Country ? elementData[elementCount - 1] : null);
    } // lastElement()
} // CountryVector.class
