// <applet code="uk.org.redfelineninja.risk.test.RiskMapTest" codebase="../../../../.." width=640 height=440></applet>

package uk.org.redfelineninja.risk.test;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.applet.*;
import java.util.*;

import uk.org.redfelineninja.image.*;
import uk.org.redfelineninja.awt.*;
import uk.org.redfelineninja.risk.client.*;

public class RiskMapTest extends Applet {
    Image map;
    boolean toggle = true;
    RiskMap rm;
    HashColorModel cm;

    public void init() {
        setLayout(new BorderLayout());

        map = getImage(getDocumentBase(), "maps/risk.gif");
        rm = new RiskMap(map);
        // rm.addMouseListener( this );

        rm.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                doCountry(e.getActionCommand());
            }
        });

        add(BorderLayout.CENTER, rm);

        Button b = new Button("Toggle Alaska");
        b.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                doToggle();
            }
        });

        add(BorderLayout.SOUTH, b);
    }

    java.util.Random rand = new java.util.Random();

    private void doCountry(String country) {
        int v = rm.getArmies(country);
        rm.setArmies(country, v + 1);

        int i = rand.nextInt();
        rm.setColor(0xff00ff00 | i);
        rm.paintZone(country);

        showStatus(country);
        rm.setSelection(country);
    } // doCountry

    private void doToggle() {
        toggle = !toggle;

        if (toggle)
            rm.setColor(0xffff00ff);
        else
            rm.setColor(0xff00ff00);

        rm.paintZone("Alaska");
    }

}
