// <applet code=ImageTest.class width=640 height=440></applet>

package uk.org.redfelineninja.test;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.beans.*;
import java.applet.*;
import uk.org.redfelineninja.awt.*;
import uk.org.redfelineninja.image.*;

public class ImageTest extends JApplet implements MouseListener {
    Image map;
    boolean toggle = true;
    PixMap p;
    HashColorModel cm;

    public void init() {
        getContentPane().setLayout(new BorderLayout());

        map = getImage(getDocumentBase(), "map.gif");
        p = new PixMap(map);
        p.addMouseListener(this);

        getContentPane().add(BorderLayout.CENTER, p);

        Button b = new Button("Toggle");
        b.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                doToggle();
            }
        });

        getContentPane().add(BorderLayout.SOUTH, b);
    }

    private void doToggle() {
        toggle = !toggle;

        if (toggle)
            p.setColor(0xffff00ff);
        else
            p.setColor(0xff00ff00);

        p.floodFill(40, 40);
        // repaint();
    }

    java.util.Random rand = new java.util.Random();

    public void mouseClicked(MouseEvent m) {
        Component c = m.getComponent();
        if (c instanceof PixMap) {
            PixMap p = (PixMap) c;

            int i = rand.nextInt();
            p.setColor(0xff00ff00 & i);

            Rectangle r = p.floodFill(m.getX(), m.getY());
            int x = r.x + r.width / 2;
            int y = r.y + r.height / 2;
            String out = "Centre Point: ( " + String.valueOf(x) + ", " + String.valueOf(y) + " )";

            // GraphicsToolkit.centerString( getGraphics(), out, x, y );
            GraphicsToolkit.centerBoxedString(getGraphics(), "10", x, y);
            showStatus(out);
        } // if
    } // mouseClicked

    public void mouseEntered(MouseEvent m) {}
    public void mouseExited(MouseEvent m) {}
    public void mousePressed(MouseEvent m) {}
    public void mouseReleased(MouseEvent m) {}
}
