// javac PixMapTest.java; appletviewer PixMapTest.java
// <applet code=PixMapTest2.class width=640 height=440></applet>

package uk.org.redfelineninja.test;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.applet.*;
import uk.org.redfelineninja.image.*;
import uk.org.redfelineninja.awt.*;

public class PixMapTest2 extends Applet {
    Image map;
    boolean toggle = true;
    PixMap p;
    HashColorModel cm;

    public void init() {
        setLayout(new BorderLayout());

        cm = new HashColorModel();

        map = getImage(getDocumentBase(), "map.gif");
        p = new PixMap(map, cm);

        int pixel = p.getPixel(40, 40);
        System.out.println("Pixel @ (40,40) is " + String.valueOf(pixel));
        cm.addTranslation(pixel, 0xffff00ff);

        add(BorderLayout.CENTER, p);

        Button b = new Button("Toggle");
        b.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                doToggle();
            }
        });

        add(BorderLayout.SOUTH, b);
    }

    private void doToggle() {
        toggle = !toggle;

        if (toggle)
            cm.addTranslation(p.getPixel(40, 40), 0xffff00ff);
        else
            cm.removeTranslation(p.getPixel(40, 40));

        p.newPixels();
        repaint();
    }

}
