// RiskTalkerListener.java

package uk.org.redfelineninja.risk.client;

import uk.org.redfelineninja.awt.BasicTalker;
import uk.org.redfelineninja.risk.client.*;
import uk.org.redfelineninja.risk.net.*;

import java.awt.event.*;

public class RiskTalkerListener implements ActionListener {
    RiskServerInterface server;

    public RiskTalkerListener(RiskServerInterface s) {
        server = s;
    }

    public void actionPerformed(ActionEvent e) {
        // lets be carefull
        if (!(e.getSource() instanceof BasicTalker))
            throw new RuntimeException("RiskTalkerListener abused");

        BasicTalker talker = (BasicTalker) e.getSource();

        server.message(talker.getText());
        talker.setText("");
    } // actionPerformed( ActionEvent )

} // RiskNetworkDialogListener.java
