// RandomRobot.java

package uk.org.redfelineninja.risk.robot;

import uk.org.redfelineninja.risk.data.Player;

import java.util.Random;

/**
 * This is currently a random legal mover.
 */
public class RandomRobot extends Robot {
    /**
     *
     */
    public RandomRobot() {
        super();
        defaultName = "Emma";
    }

    /**
     * Return a random move.
     */
    public Move bestMove(int mode) {
        Move m = new Move(game.getBoardSize());

        // add random weights (-1 to +1) to the desires
        m.scatter(1);

        // these are the weights that the random countries must overcome
        m.select = 0.7f;
        m.fortify = 0.9f;
        m.done = 0.9f;

        return m;
    } // bestMove( int )

    public static void main(String[] args) {
        Robot r = new RandomRobot();
        Robot.main(r, args);
    } // main( String [] )
} // RandomRobot.class
