// InternalServerException.java

package uk.org.redfelineninja.risk.server;

/**
 * Thrown when the server has an error that needs to be reported. The error need
 * not be fatal, merely undersiable.
 */
class InternalServerException extends RuntimeException {
    /**
     * Constructs an <tt>InternalServerException</tt> with no detail message.
     */
    public InternalServerException() {
        super();
    }

    /**
     * Constructs an <tt>InternalServerException</tt> with the supplied detail
     * message.
     */
    public InternalServerException(String s) {
        super(s);
    }
} // InternalServerException.class
