package uk.org.redfelineninja.test;

import java.util.Vector;
import uk.org.redfelineninja.util.*;

public class AdjacencyTest {
    public static void main(String args[]) {
        Vector v;

        v = new Vector();

        v.addElement("banana");
        v.addElement("tomato");
        v.addElement("orange");

        Adjacency a = new Adjacency(v);

        a.link("banana", "tomato");
        a.link("orange", "tomato");

        System.out.println(a.toString());

        a.addElement("pepper");
        a.addElement("wheel");

        a.doubleLink("pepper", "wheel");

        System.out.println(a.toString());

        a.addElement("spoon");
        a.addElement("fork");
        a.addElement("knife");
        a.addElement("mouse");
        a.addElement("green");
        a.addElement("PC");
        a.addElement("apple");
        a.addElement("Mac");
        a.addElement("Linux");
        a.addElement("Windows");
        a.addElement("Clock");
        a.addElement("Eyes");

        a.unlink("orange", "tomato");
        a.unlink("banana", "tomato");

        System.out.println(a.toString());
    }
}
