// HashColorModelTest.java

package uk.org.redfelineninja.test;

import uk.org.redfelineninja.image.HashColorModel;
import java.awt.image.*;

public class HashColorModelTest {
    public static void main(String args[]) {
        System.out.println("Expected");
        System.out.println("0 255 1024");
        System.out.println("0 512 1024");
        System.out.println("0 255 1024\n\nActual");

        HashColorModel cm = new HashColorModel();

        System.out.println(cm.getRGB(0) + " " + cm.getRGB(255) + " " + cm.getRGB(1024));

        cm.addTranslation(255, 512);
        System.out.println(cm.getRGB(0) + " " + cm.getRGB(255) + " " + cm.getRGB(1024));

        cm.removeTranslation(255);
        System.out.println(cm.getRGB(0) + " " + cm.getRGB(255) + " " + cm.getRGB(1024));

    }
}
